package org.dromara.zhishu.service;

import org.dromara.zhishu.domain.vo.SpecVo;
import org.dromara.zhishu.domain.bo.SpecBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 自定义规格设置Service接口
 *
 * @author yxy
 * @date 2025-03-27
 */
public interface ISpecService {

    /**
     * 查询自定义规格设置
     *
     * @param id 主键
     * @return 自定义规格设置
     */
    SpecVo queryById(Long id);

    SpecVo selectVoByShopId(Long shopId);

    /**
     * 分页查询自定义规格设置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 自定义规格设置分页列表
     */
    TableDataInfo<SpecVo> queryPageList(SpecBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的自定义规格设置列表
     *
     * @param bo 查询条件
     * @return 自定义规格设置列表
     */
    List<SpecVo> queryList(SpecBo bo);

    /**
     * 新增自定义规格设置
     *
     * @param bo 自定义规格设置
     * @return 是否新增成功
     */
    Boolean insertByBo(SpecBo bo);

    /**
     * 修改自定义规格设置
     *
     * @param bo 自定义规格设置
     * @return 是否修改成功
     */
    Boolean updateByBo(SpecBo bo);

    /**
     * 校验并批量删除自定义规格设置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);
}
